Index: src/main/java/com/wediscussmovies/project/WeDiscussMoviesApplication.java
===================================================================
--- src/main/java/com/wediscussmovies/project/WeDiscussMoviesApplication.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/WeDiscussMoviesApplication.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,9 +1,10 @@
 package com.wediscussmovies.project;
 
-import org.springframework.beans.factory.annotation.Autowired;
-import org.springframework.boot.CommandLineRunner;
+
 import org.springframework.boot.SpringApplication;
 import org.springframework.boot.autoconfigure.SpringBootApplication;
-import org.springframework.jdbc.core.JdbcTemplate;
+import org.springframework.context.annotation.Bean;
+import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
+import org.springframework.security.crypto.password.PasswordEncoder;
 
 @SpringBootApplication
@@ -14,4 +15,8 @@
         SpringApplication.run(WeDiscussMoviesApplication.class, args);
     }
+    @Bean
+    PasswordEncoder getPasswordEncoder(){
+        return new BCryptPasswordEncoder(10);
+    }
 
 
Index: src/main/java/com/wediscussmovies/project/repository/DiscussionRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/DiscussionRepository.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/repository/DiscussionRepository.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,12 +1,16 @@
 package com.wediscussmovies.project.repository;
 
+import com.wediscussmovies.project.model.Discussion;
+import com.wediscussmovies.project.model.Movie;
+import com.wediscussmovies.project.model.Person;
 import org.springframework.data.jpa.repository.JpaRepository;
 import org.springframework.stereotype.Repository;
 
 import java.util.List;
-import com.wediscussmovies.project.model.*;
 
 @Repository
 public interface DiscussionRepository extends JpaRepository<Discussion, Integer> {
-    public List<Discussion> findAllByTitleLike(String title);
+     List<Discussion> findAllByTitleLike(String title);
+     List<Discussion> findAllByMovie(Movie movie);
+     List<Discussion> findAllByPerson (Person person);
 }
Index: src/main/java/com/wediscussmovies/project/repository/GenreRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/GenreRepository.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/repository/GenreRepository.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,12 +1,22 @@
 package com.wediscussmovies.project.repository;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.model.Genre;
+import com.wediscussmovies.project.querymodels.GenreLikes;
 import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Query;
 import org.springframework.stereotype.Repository;
 
+import javax.transaction.Transactional;
 import java.util.List;
 
 @Repository
 public interface GenreRepository extends JpaRepository<Genre, Integer> {
-    public List<Genre> findAllByGenreType(String genre);
+     List<Genre> findAllByGenreType(String genre);
+
+     @Query(value = "select new com.wediscussmovies.project.querymodels.GenreLikes(g.genreType, count(ug.id.userId)) from Genre g" +
+             " left join UserGenres ug on ug.id.genreId = g.genreId" +
+             " group by g.genreType" +
+             " order by count(ug.id.userId) desc")
+     @Transactional
+     List<GenreLikes> findAllWithLikes();
 }
Index: src/main/java/com/wediscussmovies/project/repository/MovieRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/MovieRepository.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/repository/MovieRepository.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,12 +1,15 @@
 package com.wediscussmovies.project.repository;
 
+import com.wediscussmovies.project.model.Movie;
+import com.wediscussmovies.project.model.Person;
 import org.springframework.data.jpa.repository.JpaRepository;
 import org.springframework.stereotype.Repository;
 
 import java.util.List;
-import com.wediscussmovies.project.model.*;
 
 @Repository
 public interface MovieRepository extends JpaRepository<Movie, Integer> {
-    public List<Movie> findAllByTitleLike(String Title);
+     List<Movie> findAllByTitleLike(String Title);
+     List<Movie> findAllByDirector(Person director);
+     List<Movie> findAllByDirectorIsNull();
 }
Index: src/main/java/com/wediscussmovies/project/repository/PersonRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/PersonRepository.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/repository/PersonRepository.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,17 +1,16 @@
 package com.wediscussmovies.project.repository;
 
-import com.wediscussmovies.project.model.*;
-import com.wediscussmovies.project.model.enumerations.PersonType;
+import com.wediscussmovies.project.model.Person;
 import org.springframework.data.jpa.repository.JpaRepository;
 import org.springframework.stereotype.Repository;
 
 import java.util.List;
-import java.util.Optional;
 
 @Repository
 public interface PersonRepository extends JpaRepository<Person, Integer> {
-    public List<Person> findAllByType(Character type);
-    public List<Person> findAllByTypeAndNameLike(Character type, String name);
-    public List<Person> findAllByTypeAndSurnameLike(Character type, String surname);
-    public Optional<Person> findPersonByPersonIdAndType(Integer id, Character type);
+     List<Person> findAllByType(Character type);
+     List<Person> findAllByTypeAndNameLike(Character type, String name);
+     List<Person> findAllByTypeAndSurnameLike(Character type, String surname);
+    // Optional<Person> findPersonByPersonIdAndType(Integer id, Character type);
+     List<Person> findAllByTypeAndNameLikeOrSurnameLike(Character type,String name, String surname);
 }
Index: src/main/java/com/wediscussmovies/project/repository/ReplyRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/ReplyRepository.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/repository/ReplyRepository.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,10 +1,26 @@
 package com.wediscussmovies.project.repository;
 
+import com.wediscussmovies.project.model.Discussion;
+import com.wediscussmovies.project.model.Reply;
+import com.wediscussmovies.project.model.primarykeys.ReplyPK;
 import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Modifying;
+import org.springframework.data.jpa.repository.Query;
+import org.springframework.data.repository.query.Param;
 import org.springframework.stereotype.Repository;
-import com.wediscussmovies.project.model.*;
+
+import javax.transaction.Transactional;
+import java.sql.Date;
+import java.util.List;
 
 
 @Repository
-public interface ReplyRepository extends JpaRepository<Reply, Integer> {
+public interface ReplyRepository extends JpaRepository<Reply, ReplyPK> {
+    List<Reply> findAllByDiscussion(Discussion discussion);
+
+    @Modifying
+    @Query(value = "insert into project.replies (text,date,user_id,discussion_id) values(:text,:date,:user_id,:discussion_id)",nativeQuery = true)
+    @Transactional
+    void insertInto(@Param("text") String text, @Param("date")Date date,
+                    @Param("user_id")Integer userId,@Param("discussion_id")Integer discussionId);
 }
Index: src/main/java/com/wediscussmovies/project/repository/UserRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/UserRepository.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/repository/UserRepository.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,5 +1,5 @@
 package com.wediscussmovies.project.repository;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.model.User;
 import org.springframework.data.jpa.repository.JpaRepository;
 import org.springframework.stereotype.Repository;
@@ -9,7 +9,4 @@
 @Repository
 public interface UserRepository extends JpaRepository<User, Integer> {
-    public Optional<User> findByEmailAndPassword(String email, String password);
-    public Optional<User> findByUsernameAndPassword(String email, String password);
-    public Optional<User> findByUsername(String username);
-    public Optional<User> findByEmail(String email);
+     Optional<User> findByUsername(String username);
 }
Index: src/main/java/com/wediscussmovies/project/service/DiscussionService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/DiscussionService.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/service/DiscussionService.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,13 +1,18 @@
 package com.wediscussmovies.project.service;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.model.Discussion;
+import com.wediscussmovies.project.model.User;
 
 import java.util.List;
-import java.util.Optional;
 
 public interface DiscussionService {
     List<Discussion> listAll();
     List<Discussion> listAllByTitle(String title);
-    Optional<Discussion> findById(Integer id);
-    void save(Discussion discussion);
+    Discussion findById(Integer id);
+    void save(Character type,Integer id, String title, String text, User user);
+    void edit(Integer discussionId,Character type,Integer id, String title, String text);
+    void deleteById(Integer discussionId);
+    void likeDiscussion(Integer discussionId,Integer userId);
+    void unlikeDiscussion(Integer discussionId,Integer userId);
+    List<Discussion> findAllForPersonOrMovie(Integer id,Character type);
 }
Index: src/main/java/com/wediscussmovies/project/service/GenreService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/GenreService.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/service/GenreService.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,15 +1,17 @@
 package com.wediscussmovies.project.service;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.model.Genre;
+import com.wediscussmovies.project.querymodels.GenreLikes;
 import org.springframework.stereotype.Service;
 
 import java.util.List;
-import java.util.Optional;
 
 @Service
 public interface GenreService {
-    public List<Genre> findAll();
-    public Optional<Genre> findById(Integer id);
-    public List<Genre> findAllByType(String genre);
-    public Genre save(String genreName);
+    List<Genre> findAll();
+    Genre findById(Integer id);
+    List<Genre> findAllByType(String genre);
+    Genre save(String genreName);
+    List<GenreLikes> findAllWithLikes();
+
 }
Index: src/main/java/com/wediscussmovies/project/service/MovieService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/MovieService.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/service/MovieService.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,14 +1,35 @@
 package com.wediscussmovies.project.service;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.ajaxmodels.Grade;
+import com.wediscussmovies.project.model.Genre;
+import com.wediscussmovies.project.model.Movie;
+import com.wediscussmovies.project.model.Person;
+import com.wediscussmovies.project.model.User;
 
+import java.sql.Date;
 import java.util.List;
-import java.util.Optional;
 
 public interface MovieService {
-    public List<Movie> listAll();
-    public List<Movie> searchByTitle(String title);
-    public Optional<Movie> findById(Integer id);
-    public Movie save(Movie movie);
-    public void deleteById(Integer id);
+     List<Movie> listAll();
+     List<Movie> listAllByType(Character type);
+     List<Movie> listAllWithoutDirector();
+     List<Movie> searchByTitle(String title);
+     Movie findById(Integer id);
+     Movie save(String title, String description, String imageUrl, Date airingDate,Double  rating,
+                Integer directorId,List<Integer> actorIds,List<Integer> genreIds);
+
+     Movie edit(Integer movieId,String title, String description, String imageUrl, Date airingDate,Double  rating,
+                Integer directorId,List<Integer> actorIds, List<Integer> genreIds);
+
+     List<Person> findAllActorsForMovie(Movie movie);
+     List<Genre> findAllGenresForMovie(Movie movie);
+
+     void likeMovie(Integer movieId, Integer userId);
+     void unlikeMovie(Integer movieId,Integer userId);
+
+     List<Movie> findLikedMoviesByUser(User user);
+
+     void deleteById(Integer id);
+
+     void addGradeMovie(Integer movieId, User user, Grade grade);
 }
Index: src/main/java/com/wediscussmovies/project/service/PersonService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/PersonService.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/service/PersonService.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,20 +1,30 @@
 package com.wediscussmovies.project.service;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.ajaxmodels.Grade;
+import com.wediscussmovies.project.model.Movie;
+import com.wediscussmovies.project.model.Person;
+import com.wediscussmovies.project.model.User;
 
+import java.sql.Date;
 import java.util.List;
-import java.util.Optional;
 
 public interface PersonService {
+    List<Person> findAll();
      List<Person> findAllDirectors();
      List<Person> findAllActors();
-    Optional<Person> findById(Integer person_id);
-    Optional<Person> findActorById(Integer id);
-    Optional<Person> findDirectorById(Integer id);
-    boolean save(Person person);
-    List<Person> findActorsByNameLike(String name);
-    List<Person> findActorsBySurnameLike(String surname);
-    List<Person> findDirectorsByNameLike(String name);
-    List<Person> findDirectorsBySurnameLike(String surname);
+    Person findById(Integer person_id);
+
+    Person  save(String name, String surname, Character type,
+                 Date birthDate, String image_url, String description, List<Integer> movieIds);
+
+    Person edit(Integer personId, String name, String surname, Character type,
+                Date birthDate, String image_url, String description, List<Integer> movieIds);
+
+    List<Person> findPersonsByNameOrSurname(Character type,String searchQuery);
+
+    List<Movie> findAllMoviesByPerson(Person person);
+
+    void deleteById(Integer id);
+    void addGradePerson(Integer personId, User user, Grade grade);
 
 }
Index: src/main/java/com/wediscussmovies/project/service/ReplyService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/ReplyService.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/service/ReplyService.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,12 +1,21 @@
 package com.wediscussmovies.project.service;
 
+import com.wediscussmovies.project.model.Discussion;
 import com.wediscussmovies.project.model.Reply;
+import com.wediscussmovies.project.model.User;
+import com.wediscussmovies.project.model.primarykeys.ReplyPK;
 
-import java.util.Optional;
+import java.util.List;
 
 public interface ReplyService {
-    public Reply save(Reply r);
-    public void delete(Reply r);
-    Optional<Reply> findById(Long id);
+    Reply edit(Integer replyId, Integer discussionId, String text);
+    void delete(Integer discussionId,Integer replyId);
+    Reply findById(Integer discussionId, Integer replyId);
+    void save(Integer discussionId, String text, User user);
+    void likeReply(Integer replyId,Integer userId);
+    void unlikeReply(Integer replyId,Integer userId);
+    List<Reply> findAllByDiscussion(Discussion discussion);
+
+
 
 }
Index: src/main/java/com/wediscussmovies/project/service/UserService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/UserService.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/service/UserService.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,11 +1,12 @@
 package com.wediscussmovies.project.service;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.model.User;
+import org.springframework.security.core.userdetails.UserDetailsService;
 
 import javax.servlet.http.HttpServletRequest;
 import java.util.Optional;
 
-public interface UserService {
-    public Optional<User> login(String email, String password);
-    public Optional<User> register(HttpServletRequest request, String email, String password, String confirmPassword, String username, String name, String surname);
+public interface UserService extends UserDetailsService {
+     User findByUsername(String username);
+     User register(String email, String username, String password, String confirmPassword, String name, String surname);
 }
Index: src/main/java/com/wediscussmovies/project/service/impl/DiscussionServiceImpl.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/impl/DiscussionServiceImpl.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/service/impl/DiscussionServiceImpl.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,38 +1,145 @@
 package com.wediscussmovies.project.service.impl;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.model.exception.DiscussionNotExistException;
+import com.wediscussmovies.project.model.exception.MovieIdNotFoundException;
+import com.wediscussmovies.project.model.exception.PersonNotExistException;
+import com.wediscussmovies.project.model.exception.UserNotExistException;
 import com.wediscussmovies.project.repository.DiscussionRepository;
+import com.wediscussmovies.project.model.Discussion;
+import com.wediscussmovies.project.model.Movie;
+import com.wediscussmovies.project.model.Person;
+import com.wediscussmovies.project.model.User;
+import com.wediscussmovies.project.repository.MovieRepository;
+import com.wediscussmovies.project.repository.PersonRepository;
+import com.wediscussmovies.project.repository.UserRepository;
 import com.wediscussmovies.project.service.DiscussionService;
+import com.wediscussmovies.project.service.MovieService;
+import com.wediscussmovies.project.service.PersonService;
+import com.wediscussmovies.project.service.UserService;
 import org.springframework.stereotype.Service;
 
+import java.sql.Date;
+import java.time.LocalDate;
 import java.util.List;
-import java.util.Optional;
 
 @Service
 public class DiscussionServiceImpl implements DiscussionService {
+
     private final DiscussionRepository discussionRepository;
+    private final UserRepository userRepository;
 
-    public DiscussionServiceImpl(DiscussionRepository discussionRepository) {
+    private final MovieRepository movieRepository;
+    private final PersonRepository personRepository;
+
+    public DiscussionServiceImpl(DiscussionRepository discussionRepository, UserRepository userRepository,
+                                 MovieRepository movieRepository, PersonRepository personRepository) {
         this.discussionRepository = discussionRepository;
+        this.userRepository = userRepository;
+        this.movieRepository = movieRepository;
+        this.personRepository = personRepository;
+    }
+
+
+
+
+    @Override
+    public List<Discussion> listAll() {
+        return this.discussionRepository.findAll();
     }
 
     @Override
-    public List<Discussion> listAll() {
-        return discussionRepository.findAll();
-    }
+    public void save(Character type,Integer id,String title, String text,User user) {
+        Date date = Date.valueOf(LocalDate.now());
+        Discussion discussion;
 
-    @Override
-    public void save(Discussion discussion) {
+        if (type.equals('M')) {
+            discussion = new Discussion('M',text,title,date,user);
+            this.addMovieForDiscussion(id,discussion);
+        }
+        else{
+            discussion = new Discussion('P',text,title,date,user);
+            this.addPersonForDiscussion(id,discussion);
+        }
+
+
+
         discussionRepository.save(discussion);
     }
 
     @Override
-    public Optional<Discussion> findById(Integer id) {
-        return discussionRepository.findById(id);
+    public void edit(Integer discussionId, Character type, Integer id, String title, String text) {
+        Discussion discussion = this.findById(discussionId);
+
+        discussion.setText(text);
+        discussion.setTitle(title);
+        discussion.setType(type);
+        discussion.setMovie(null);
+        discussion.setPerson(null);
+
+        if (type.equals('M')) {
+            this.addMovieForDiscussion(id,discussion);
+        }
+        else{
+          this.addPersonForDiscussion(id,discussion);
+        }
+        this.discussionRepository.save(discussion);
+
+    }
+
+    @Override
+    public void deleteById(Integer discussionId) {
+        this.discussionRepository.deleteById(discussionId);
+    }
+
+    @Override
+    public void likeDiscussion(Integer discussionId, Integer userId) {
+        //ova fali od dijagram
+    }
+
+    @Override
+    public void unlikeDiscussion(Integer discussionId, Integer userId) {
+        // ova fali od dijagram
+    }
+
+    @Override
+    public List<Discussion> findAllForPersonOrMovie(Integer id,Character type) {
+        if (type.equals('M'))
+        {
+            Movie movie = this.findMovieById(id);
+            return this.discussionRepository.findAllByMovie(movie);
+        }
+        Person person  = this.findPersonById(id);
+        return this.discussionRepository.findAllByPerson(person);
+
+    }
+
+    @Override
+    public Discussion findById(Integer id) {
+        return discussionRepository.findById(id).orElseThrow(() -> new DiscussionNotExistException(id));
     }
 
     @Override
     public List<Discussion> listAllByTitle(String title) {
+        if(title == null || title.isEmpty())
+         return this.listAll();
         return discussionRepository.findAllByTitleLike("%"+title+"%");
     }
+    private void addMovieForDiscussion(Integer id,Discussion discussion){
+        Movie movie = findMovieById(id);
+        discussion.setMovie(movie);
+
+    }
+
+    private void addPersonForDiscussion(Integer id, Discussion discussion){
+        Person person = findPersonById(id);
+        discussion.setPerson(person);
+
+    }
+    private Movie findMovieById(Integer id){
+        return this.movieRepository.findById(id).orElseThrow(() -> new MovieIdNotFoundException(id));
+    }
+    private Person findPersonById(Integer id){
+        return this.personRepository.findById(id).orElseThrow(() -> new PersonNotExistException(id));
+
+    }
 }
Index: src/main/java/com/wediscussmovies/project/service/impl/GenreServiceImpl.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/impl/GenreServiceImpl.java	(revision 3ded84dfbf8ff25bf27cc822ac97b84a063fa95a)
+++ src/main/java/com/wediscussmovies/project/service/impl/GenreServiceImpl.java	(revision e0ef1b13a29101c3f7a56f68da8dcdc8cce98b76)
@@ -1,11 +1,12 @@
 package com.wediscussmovies.project.service.impl;
 
-import com.wediscussmovies.project.model.*;
+import com.wediscussmovies.project.model.exception.GenreNotExistException;
+import com.wediscussmovies.project.querymodels.GenreLikes;
 import com.wediscussmovies.project.repository.GenreRepository;
+import com.wediscussmovies.project.model.Genre;
 import com.wediscussmovies.project.service.GenreService;
 import org.springframework.stereotype.Service;
 
 import java.util.List;
-import java.util.Optional;
 
 @Service
@@ -18,11 +19,11 @@
 
     @Override
-    public Optional<Genre> findById(Integer id) {
-        return genreRepository.findById(id);
+    public Genre findById(Integer id) {
+        return this.genreRepository.findById(id).orElseThrow(() -> new GenreNotExistException(id));
     }
 
     @Override
     public List<Genre> findAllByType(String genre) {
-        return genreRepository.findAllByGenreType(genre);
+        return this.genreRepository.findAllByGenreType(genre);
     }
 
@@ -30,10 +31,15 @@
     public Genre save(String genreName) {
        Genre genre = new Genre(genreName);
-        return genreRepository.save(genre);
+        return this.genreRepository.save(genre);
+    }
+
+    @Override
+    public List<GenreLikes> findAllWithLikes() {
+        return this.genreRepository.findAllWithLikes();
     }
 
     @Override
     public List<Genre> findAll() {
-        return genreRepository.findAll();
+        return this.genreRepository.findAll();
     }
 }
